/************************************************************************
 * Probeprogramm...: client.c						*
 * Zweck...........: Kundenprogramm, dass etwas an Server sendet	*
 ************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>
#include<signal.h>
#include<errno.h>


int empfaenger(short port);
int sender(char *host,short port,int v);

#define PUFLEN 1024
char puffer[PUFLEN];
char errmsg[PUFLEN];

int v=0;

int beende=0;
void handlesigaction(int sig,siginfo_t *info,void *context)
{
  fprintf(stderr,"Signal %d von Proze %d/User %d empfangen ...\n",
	          sig,info->si_pid,info->si_uid);
  switch(sig)
  {
  case SIGINT:
  case SIGTERM:
	beende=1;
	break;
  } 
}

void installhandler(int sig)
{
  struct sigaction action;
  action.sa_flags = SA_SIGINFO;
  action.sa_sigaction = handlesigaction;
  sigemptyset(&action.sa_mask);
  sigaction(sig,&action,NULL);
}

int main(int argc,char **argv)
{
  char rechner[50];
  int port=0;
  int o;
  
  while((o=getopt(argc,argv,"vs"))!=-1)
  {
    switch(o)
    {
      case 'v':
               v = 1;
               break;
      case 's':
               installhandler(SIGTERM); 
               installhandler(SIGINT); 
               installhandler(SIGUSR1); 
               installhandler(SIGUSR2); 
               break;
    }
  }

  if(optind == argc)
  {
    /* Empfaenger mit mit Selbstwahlport */
    empfaenger(0);
  }
  else if(argc-optind == 1)
  {
     if(sscanf(argv[optind],"%d",&port)==1)
     {
       /* Empfaenger soll auf Port port lauschen ... */
       empfaenger(port);
     }
     else if(sscanf(argv[optind],"%[^:]:%d",rechner,&port)==2)
     {
        fprintf(stderr,"Sende an %s port %d\n",rechner,port);
        sender(rechner,port,v);
     }
     else
     {
        fprintf(stderr,"Aufruf: %s [-v] [port | hostname port hostname:port]\n",argv[0]);
     }
  }
  else if(argc-optind == 2)
  {
    strcpy(rechner,argv[optind]);
    port = atoi(argv[2]);
    
    fprintf(stderr,"Sende an %s port %d\n",rechner,port);
    sender(rechner,port,v);
  }
}

int sender(char *host,short port,int v)
{
   int s;		/* Socket */
   struct sockaddr_in partner;
   struct hostent *hp,*gethostbyname();
   int slang;

   if((s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP))<0)
   {
      sprintf(errmsg,"socket(%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   /* Adresse des Servers aus Kommandozeitenparameter ermitteln */
   partner.sin_family = AF_INET;
   hp = gethostbyname(host);
   if(hp == NULL)
   {
      fprintf(stderr,"gethostbyname(%s:%d): Rechner %s nicht gefunden\n",
					   __FILE__,__LINE__,host);
      exit(1);
   }
   bcopy(hp->h_addr_list[0],&partner.sin_addr,hp->h_length);
   partner.sin_port = htons(port);

   if(connect(s,(struct sockaddr *)&partner,sizeof(partner))<0)
   {
      sprintf(errmsg,"connect(%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   while(fgets(puffer,PUFLEN-1,stdin)!=NULL)
   {
       if(v) printf(puffer);
       if(write(s,puffer,(slang=strlen(puffer)))<0)
       {
	   sprintf(errmsg,"write(%s:%d):",__FILE__,__LINE__);
	   perror(errmsg);
       }
   }
  
   /*--- Ende ---- */
   close(s);
}

/********************************************************
 * empfaenger : dient als Server                 	*
 ********************************************************/
int empfaenger(short port)
{
   int s0,sneu;
   struct sockaddr_in meineadr;
   struct sockaddr_in kundeadr;
   int meineadrlen = sizeof(meineadr);
   int kundeadrlen = sizeof(kundeadr);
   char rechnername[80];
   int llang;
   char *ptr;
   int r,rest;   
   
   port = htons(port);
   
   if((s0 = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
   {   
      sprintf(errmsg,"socket (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   /* Binde an Adresse und waehle Portnr. frei falls port == 0; */
   bzero((char *)&meineadr,sizeof(meineadr));
   meineadr.sin_family = AF_INET;
   meineadr.sin_addr.s_addr = INADDR_ANY;
   meineadr.sin_port = port;
   if((bind(s0,(struct sockaddr *)&meineadr,sizeof(meineadr))) < 0)
   {
      sprintf(errmsg,"bind (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
      
   /* Ermittle Rechner und gewaehlte Protnummer */
   if(gethostname(rechnername,80)<0)
   {
      sprintf(errmsg,"gethostname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
   }

   if(getsockname(s0,(struct sockaddr *)&meineadr,&meineadrlen)<0)
   {   
      sprintf(errmsg,"getsockname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
   fprintf(stderr,"Rechner: %s Port: %d\n",rechnername,ntohs(meineadr.sin_port));

   listen(s0,1);
   beende=0;
   while((sneu = accept(s0,(struct sockaddr *)&kundeadr,&kundeadrlen))<0
         && !beende)
   {
      sprintf(errmsg,"accept (%s:%d) Err %d:",__FILE__,__LINE__,errno);
      perror(errmsg);
      switch(errno)
      {
        case EAGAIN:
        case EINTR:
             write(2,"accept: nochmal\n",sizeof("accept: nochmal\n"));
	     errno=0;
             continue;
        default:
          exit(1); 
      }
   }
   if(beende)
   {
     fprintf(stderr,"Beendigung waehrend accept!\n");
     exit(1);
   }
   fprintf(stderr,"Verbindung von %s:%d ...\n",inet_ntoa(kundeadr.sin_addr),kundeadr.sin_port);

   errno=0;
   while((llang = read(sneu,puffer,PUFLEN-1))!=0 && !beende)
   {
     if(llang<0)
     {
       switch(errno)
       {
         case EAGAIN: 
         case EINTR:
               write(2,"read: nochmal\n",sizeof("read: nochmal\n"));
	       errno=0;
	       continue;
         default:
               break;
       } 
     }
     puffer[llang]='\0';
     rest = llang;
     ptr = puffer;
     errno=0;
     while((r=write(1,ptr,rest))!=0 && rest > 0)
     {
       if(r<0)
       { switch(errno)
         {
            case EAGAIN: 
            case EINTR:
               write(2,"write: nochmal\n",sizeof("write: nochmal\n"));
	       errno=0;
	       continue;
           default:
                break;
         } 
       }
       ptr += r;
       rest -= r;
     }
   } 

   if(llang<0 && errno !=0)
   {   
     sprintf(errmsg,"read (%s:%d):",__FILE__,__LINE__);
     perror(errmsg);
   }
   write(2,"Ende, schliee Sockets\n",sizeof("Ende, schliee Sockets\n"));
   /* sockets schliessen */
   close(sneu);
   close(s0);
}


