/************************************************************************
 * Probeprogramm...: client.c						*
 * Zweck...........: Kundenprogramm, dass etwas an Server sendet	*
 ************************************************************************/
#include<stdio.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>

int empfaenger(short port);
int sender(char *host,short port,int v);

#define PUFLEN 1024
char puffer[PUFLEN];
char errmsg[PUFLEN];

int v=0;

main(int argc,char **argv)
{
  int optind=1;
  int opterr=0;
  char rechner[50];
  int port=0;

  if(argc > 1 && strcmp(argv[optind],"-v")==0)
  {
    v = 1;
    optind++;
  }
  if(optind == argc)
  {
    /* Empfaenger mit mit Selbstwahlport */
    empfaenger(0);
  }
  else if(argc-optind == 1)
  {
     if(sscanf(argv[optind],"%d",&port)==1)
     {
       /* Empfaenger soll auf Port port lauschen ... */
       empfaenger(port);
     }
     else if(sscanf(argv[optind],"%[^:]:%d",rechner,&port)==2)
     {
        fprintf(stderr,"Sende an %s port %d\n",rechner,port);
        sender(rechner,port,v);
     }
     else
     {
        fprintf(stderr,"Aufruf: %s [-v] [port | hostname port hostname:port]\n",argv[0]);
     }
  }
  else if(argc-optind == 2)
  {
    strcpy(rechner,argv[optind]);
    port = atoi(argv[2]);
    
    fprintf(stderr,"Sende an %s port %d\n",rechner,port);
    sender(rechner,port,v);
  }
}

int sender(char *host,short port,int v)
{
   int s;		/* Socket */
   struct sockaddr_in partner;
   struct hostent *hp,*gethostbyname();
   int slang;

   if((s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP))<0)
   {
      sprintf(errmsg,"socket(%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   /* Adresse des Servers aus Kommandozeitenparameter ermitteln */
   partner.sin_family = AF_INET;
   hp = gethostbyname(host);
   if(hp == NULL)
   {
      fprintf(stderr,"gethostbyname(%s:%d): Rechner %s nicht gefunden\n",
					   __FILE__,__LINE__,host);
      exit(1);
   }
   bcopy(hp->h_addr_list[0],&partner.sin_addr,hp->h_length);
   partner.sin_port = htons(port);

   if(connect(s,(struct sockaddr *)&partner,sizeof(partner))<0)
   {
      sprintf(errmsg,"connect(%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   while(fgets(puffer,PUFLEN-1,stdin)!=NULL)
   {
       if(v) printf(puffer);
       if(write(s,puffer,(slang=strlen(puffer)))<0)
       {
	   sprintf(errmsg,"write(%s:%d):",__FILE__,__LINE__);
	   perror(errmsg);
       }
   }
  
   /*--- Ende ---- */
   close(s);
}

/********************************************************
 * empfaenger : dient als Server                 	*
 ********************************************************/
int empfaenger(short port)
{
   int s0,sneu;
   struct sockaddr_in meineadr;
   struct sockaddr_in kundeadr;
   int meineadrlen = sizeof(meineadr);
   int kundeadrlen = sizeof(kundeadr);
   char rechnername[80];
   int llang;
   char *ptr;
   int r,rest;   
   
   port = htons(port);
   
   if((s0 = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
   {   
      sprintf(errmsg,"socket (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   /* Binde an Adresse und waehle Portnr. frei falls port == 0; */
   bzero((char *)&meineadr,sizeof(meineadr));
   meineadr.sin_family = AF_INET;
   meineadr.sin_addr.s_addr = INADDR_ANY;
   meineadr.sin_port = port;
   if((bind(s0,(struct sockaddr *)&meineadr,sizeof(meineadr))) < 0)
   {
      sprintf(errmsg,"bind (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
      
   /* Ermittle Rechner und gewaehlte Protnummer */
   if(gethostname(rechnername,80)<0)
   {
      sprintf(errmsg,"gethostname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
   }

   if(getsockname(s0,(struct sockaddr *)&meineadr,&meineadrlen)<0)
   {   
      sprintf(errmsg,"getsockname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
   fprintf(stderr,"Rechner: %s Port: %d\n",rechnername,ntohs(meineadr.sin_port));

   listen(s0,1);

   if((sneu = accept(s0,(struct sockaddr *)&kundeadr,&kundeadrlen))<0)
   {
      sprintf(errmsg,"accept (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1); 
   }
   fprintf(stderr,"Verbindung von %s:%d ...\n",inet_ntoa(kundeadr.sin_addr),kundeadr.sin_port);

   while((llang = read(sneu,puffer,PUFLEN-1))>0)
   {
     puffer[llang]='\0';
     rest = llang;
     ptr = puffer;
     while((r=write(1,ptr,rest))>0 && rest > 0)
     {
       ptr += r;
       rest -= r;
     }
   } 

   if(llang<0)
   {   
     sprintf(errmsg,"read (%s:%d):",__FILE__,__LINE__);
     perror(errmsg);
     exit(1);
   }
   /* sockets schliessen */
   close(sneu);
   close(s0);
}


