/************************************************************************
 * Probeprogramm...: Tcpdeamon.c                                        *
 * Zweck...........: Einfachster Deamon zum Protokoll berprfen	*
 * Author..........: Rudolf Weber 1997                                  *
 * Copyright.......: GNU                                                *
 ************************************************************************/
#include<stdio.h>
#include<sys/types.h>
#include<sys/times.h>
#ifdef AIX
#include<sys/select.h>
#endif
#include<unistd.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>
#include<arpa/inet.h>

int empfaenger(short port);

#define PUFLEN 1024
char puffer[PUFLEN];
char errmsg[PUFLEN];

int v=0;

main(int argc,char **argv)
{
  int optind=1;
  int opterr=0;
  struct servent *service=NULL;
  int port=0;

  if(argc > 1 && strcmp(argv[optind],"-v")==0)
  {
    v = 1;
    optind++;
  }
  if(optind == argc)
  {
    /* Empfaenger mit mit Selbstwahlport */
    empfaenger(0);
  }
  else if(argc-optind == 1)
  {
     if(sscanf(argv[optind],"%d",&port)==1)
     {
       /* Empfaenger soll auf Port port lauschen ... */
       empfaenger(port);
     }
     else if((service=getservbyname(argv[optind],"tcp"))!=NULL)
     {
       empfaenger(ntohs(service->s_port));
     }
     else
     {
        fprintf(stderr,"Aufruf: %s [-v] [port]\n",argv[0]);
     }
  }
}

/********************************************************
 * empfaenger : dient als Server                 	*
 ********************************************************/
int empfaenger(short port)
{
   int s0,sneu;
   struct sockaddr_in meineadr;
   struct sockaddr_in kundeadr;
   struct sockaddr_in kundeadr2;
   int meineadrlen = sizeof(meineadr);
   int kundeadrlen = sizeof(kundeadr);
   int kundeadr2len = sizeof(kundeadr2);
   char rechnername[80];
   int llang,tlang;
   char *ptr;
   int r,rest;   
   
   port = htons(port);
   
   if((s0 = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
   {   
      sprintf(errmsg,"socket (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }

   /* Binde an Adresse und waehle Portnr. frei falls port == 0; */
   bzero((char *)&meineadr,sizeof(meineadr));
   meineadr.sin_family = AF_INET;
   meineadr.sin_addr.s_addr = INADDR_ANY;
   meineadr.sin_port = port;
   if((bind(s0,(struct sockaddr *)&meineadr,sizeof(meineadr))) < 0)
   {
      sprintf(errmsg,"bind (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
      
   /* Ermittle Rechner und gewaehlte Protnummer */
   if(gethostname(rechnername,80)<0)
   {
      sprintf(errmsg,"gethostname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
   }

   if(getsockname(s0,(struct sockaddr *)&meineadr,&meineadrlen)<0)
   {   
      sprintf(errmsg,"getsockname (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1);
   }
   fprintf(stderr,"Rechner: %s (%s) Port: %d\n",rechnername,
	   inet_ntoa(meineadr.sin_addr),ntohs(meineadr.sin_port));

   listen(s0,1);

   if((sneu = accept(s0,(struct sockaddr *)&kundeadr,&kundeadrlen))<0)
   {
      sprintf(errmsg,"accept (%s:%d):",__FILE__,__LINE__);
      perror(errmsg);
      exit(1); 
   }
   fprintf(stderr,"Partneraddresse nach accept %s \n",inet_ntoa(kundeadr.sin_addr));
   if(getpeername(sneu,(struct sockaddr *)&kundeadr2,&kundeadr2len)<0)
   {
     sprintf(errmsg,"getpeername (%s,%d):",__FILE__,__LINE__);
     perror(errmsg);
   }
   fprintf(stderr,"Partneraddresse nach getpeername %s \n",inet_ntoa(kundeadr2.sin_addr));
   llang = 1;
   tlang = 1;
   while(llang > 0 && tlang >0)
   {
     int bereit;
     fd_set rfd;
     FD_ZERO(&rfd);
     FD_SET(0,&rfd);
     FD_SET(sneu,&rfd);
     if((bereit=select(sneu+1,&rfd,NULL,NULL,NULL))<0)
     {
       perror("select");exit(1);
     }
     if(bereit == 0) continue;
     if(FD_ISSET(0,&rfd))
     {
       tlang=read(0,puffer,PUFLEN-1);
       puffer[tlang]='\0';
       rest = tlang;
       ptr = puffer;
       while((r=write(sneu,ptr,rest))>0 && rest > 0)
       {
	 ptr +=r;
	 rest -= r;
       }
     }
     if(FD_ISSET(sneu,&rfd))
     {
       llang = read(sneu,puffer,PUFLEN-1);
       puffer[llang]='\0';
       rest = llang;
       ptr = puffer;
       while((r=write(1,ptr,rest))>0 && rest > 0)
       {
	 ptr += r;
	 rest -= r;
       }
     }
   }
   
   if(llang<0)
   {   
     sprintf(errmsg,"read (%s:%d):",__FILE__,__LINE__);
     perror(errmsg);
     exit(1);
   }
   /* sockets schliessen */
   close(sneu);
   close(s0);
}



